GSKKFDGenerator (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.crypto.agreement.kdf

## Class GSKKFDGenerator

- java.lang.Object
- - org.bouncycastle.crypto.agreement.kdf.GSKKFDGenerator

- All Implemented Interfaces:
    DerivationFunction, DigestDerivationFunction

      public class GSKKFDGenerator
      extends java.lang.Object
      implements DigestDerivationFunction

  BSI Key Derivation Function for Session Keys (see BSI-TR-03111 Section 4.3.3)

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GSKKFDGenerator(Digest digest)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `generateBytes(byte[] out, int outOff, int len)`
    `Digest` | `getDigest()` return the message digest used as the basis for the function
    `void` | `init(DerivationParameters param)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GSKKFDGenerator

          public GSKKFDGenerator(Digest digest)

  - ### Method Detail

    - #### getDigest

          public Digest getDigest()

      Description copied from interface: `DigestDerivationFunction`
      return the message digest used as the basis for the function
      Specified by:
        `getDigest` in interface `DigestDerivationFunction`

    - #### init

          public void init(DerivationParameters param)

      Specified by:
        `init` in interface `DerivationFunction`

    - #### generateBytes

          public int generateBytes(byte[] out,
                                   int outOff,
                                   int len)
                            throws DataLengthException,
                                   java.lang.IllegalArgumentException

      Specified by:
        `generateBytes` in interface `DerivationFunction`
      Throws:
        `DataLengthException`
        `java.lang.IllegalArgumentException`